#if !defined(AFX_HISTVIEWFRAME_H__47A52CC3_E202_11D2_ACBD_00C0F6B0E2D0__INCLUDED_)
#define AFX_HISTVIEWFRAME_H__47A52CC3_E202_11D2_ACBD_00C0F6B0E2D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HistViewFrame.h : _xZkqqHx_iDhHiDgCiDfPiBfL_xHqqkZx_ _xZkqqHx_iDhEiDeAiDeDiDiL_xHqqkZx_
//

#include "TolBrTools.h"			// For CFCTolBrTools.
// 05.01.21 Fukushiro M. 1_xZkqqHx_iNhDiNoNiPjM_xHqqkZx_ ()
//#include "TolBrHTreeCtl.h"		// For CFCTolBrHTreeCtl.
#include "TolBrSheet.h"			// For CFCTolBrSheet.
#include "TolBrLayer.h"			// For CFCTolBrLayer.
#include "TolBrObjLabel.h"		// For CFCTolBrObjLabel.
#include "FrameWnd.h"			// For FFGetMainWnd().
#include "HistViewDoc.h"		// for CFCHistViewDoc.
#include "MainFrame.h"			// Superclass.
#include "HistFrameTmpl.h"		// Superclass.

#ifdef SUPER_CLASS
#undef SUPER_CLASS
#endif
#define SUPER_CLASS CFCHistFrameTmpl<CFCMainFrame, CFCHistViewDoc>


class CFCWndHistoryTree;
class CFCDlgHistFindResults;
class CFCWndHistFindPanel;
class CFCDlgDsmBookmark;

class CFCHistViewDoc;

/*************************************************************************
 * <_xZkqqHx_jHpBiLjD_xHqqkZx_>	FTHtreeMoveEach
 *
 * <_xZkqqHx_iLeAjEfM_xHqqkZx_>	_xZkqqHx_jHjKjHpAiCmMiInKjDkOjCfAiImKiBeC_xHqqkZx_
 *
 * <_xZkqqHx_jHjKjHpA_xHqqkZx_>	06.03.12 Fukushiro M. _xZkqqHx_iNoMjAkM_xHqqkZx_
 *************************************************************************/
enum FTHtreeMoveEach
{
	FD_HTREE_MOVE_OPERATION_EACH = 1,	// 1_xZkqqHx_jBiAiNoMjCfAiImKiCmFjHjKjHpAiInKjDkOiBeC_xHqqkZx_
	FD_HTREE_MOVE_LTT_EACH,				// _xZkqqHx_jClHiNgMjCfAiImKiCmFjHjKjHpAiInKjDkOiBeC_xHqqkZx_
	FD_HTREE_MOVE_TIME_EACH,			// _xZkqqHx_iMgPiJnPiOjOiKnEjCfAiImKiCmFjHjKjHpAiInKjDkOiBeC_xHqqkZx_
}; // enum FTHtreeMoveEach.

/////////////////////////////////////////////////////////////////////////////
// CFCHistViewFrame _xZkqqHx_iDhEiDiMiBfLiDiA_xHqqkZx_

class CFCHistViewFrame : public SUPER_CLASS
{
protected:
typedef SUPER_CLASS BASE_CLASS;

	DECLARE_DYNCREATE(CFCHistViewFrame)

protected:
	// _xZkqqHx_jDkOjDeJjAlGjAkMiCmJiOgHjHhAiClDiCoKiCoJiDhGiDiNiDgFiDeOiDgH_xHqqkZx_ _xZkqqHx_iDfCiDjDiDfIiDgHiDiJiDeOiDfOiBeC_xHqqkZx_
	CFCHistViewFrame ();

// _xZkqqHx_iDiGiBfLiDfFiKnGjAjEiBeC_xHqqkZx_
public:
	virtual long	GetHiMoveOperation (long& lOpeValue) const;
	virtual CFCDlgHistFindResults*	GetHtreeFindResults ();	// _xZkqqHx_jHjKjHpAiMjPiNpFiMiLiJmKiDhAiDgMiDiLiBeC_xHqqkZx_
	virtual CFCWndHistFindPanel*	GetHtreeFindPanel ();	// _xZkqqHx_jHjKjHpAiMjPiNpFiDhAiDgMiDiLiBeC_xHqqkZx_
	virtual CFCDlgDsmBookmark*		GetDsmBookmarkPanel ();
// 06.04.11 Fukushiro M. 1_xZkqqHx_iNhDjCmHiJmB_xHqqkZx_ ()
	virtual void	UseTimeIndexChangedNotify (BOOL bIsUseTimeIndex);	// _xZkqqHx_jFnCiPfHiOjOiKnEiDeDiDjDiDgGiDgCiDeOiDfIiCpAiOgHiCkEiCkJiBeI_xHqqkZx_

protected:
	//----- _xZkqqHx_iPiJiKpKiJlLjDjJiCmMiKnGjAjE_xHqqkZx_ -----
	virtual void	OnFirstExecute ();
	virtual void	PostOnCreate (CFrameWnd* pWndFrame);
	virtual void	PreOnDestroy ();
//----- 06.10.30 Fukushiro M. _xZkqqHx_jFmPiNfIjBeP_xHqqkZx_ ()-----
//	virtual void	GetZoomToolBarInfo (DWORD& idCmd,		// _xZkqqHx_iDgPiBfLiCmJiKiEiCoIjAfFiCoJiDfCiDhNiDjDiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
//										DWORD& idRes,		// _xZkqqHx_iDgPiBfLiCkKiDiNiBfLiDgIiClHiCoJiDgDiBfLiDiLiDgPiBfLiDiKiDfMiBfLiDfIiCmM_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
//										DWORD& idStr) const;// _xZkqqHx_iDgPiBfLiCkKiDiNiBfLiDgIiClHiCoJiDfOiDeDiDgHiDiLiDiKiDfMiBfLiDfIiCmM_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
//----- 06.10.30 Fukushiro M. _xZkqqHx_jFmPiNfIiMoD_xHqqkZx_ ()-----
	virtual void	GetZoomToolBarInfo (DWORD& idCmd) const;	// _xZkqqHx_iDgPiBfLiCmJiKiEiCoIjAfFiCoJiDfCiDhNiDjDiDgI_xHqqkZx_ID_xZkqqHx_iCpAiOhHjCoIiBeC_xHqqkZx_
//----- 06.10.30 Fukushiro M. _xZkqqHx_jFmPiNfIiPeJ_xHqqkZx_ ()-----

//----- 06.04.06 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	virtual const UINT*	GetIndicatorArray () const;
//	virtual long	GetIndicatorArraySize () const;
//----- 06.04.06 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

// _xZkqqHx_iDiGiBfLiDfFjFmPjAjEiBeC_xHqqkZx_
protected:
	long	m_lHiMoveOperationKind;		// _xZkqqHx_jHjKjHpAjGnIiCmMiInKjDkOjCfAiImKiBeC_xHqqkZx_
	long	m_lHiMoveOperationValue;	// _xZkqqHx_jHjKjHpAjGnIiCmMiInKjDkOjCfAiImKiCmMjCgMiBeC_xHqqkZx_
	CFCDlgHistFindResults*	m_wndHistFindResults;	// _xZkqqHx_jHjKjHpAiMjPiNpFiMiLiJmKiDhAiDgMiDiLiBeC_xHqqkZx_
	CFCWndHistFindPanel*	m_wndHistFindPanel;		// _xZkqqHx_jHjKjHpAiMjPiNpFiDhAiDgMiDiLiBeC_xHqqkZx_
	CFCDlgDsmBookmark*		m_wndDsmBookmark;		// DSM_xZkqqHx_iDhFiDgCiDeOiDhNiBfLiDeOiDhAiDgMiDiLiBeC_xHqqkZx_

//----- 06.04.06 Fukushiro M. _xZkqqHx_iNoNiPjMiOgO_xHqqkZx_ ()-----
//	//----- _xZkqqHx_iDfIiDgFiBfLiDfOiDfIiDgPiBfLiCmMiPoOjFpB_xHqqkZx_ -----
//	GUID		m_guidSessionUserId;	// _xZkqqHx_iDfKiDgCiDfGiDiHiDjDiDiGiBfLiDfFiBfLiCgIiCgDiBeC_xHqqkZx_
//	WString		m_wstrSessionUserName;	// _xZkqqHx_iDfKiDgCiDfGiDiHiDjDiDiGiBfLiDfFiBfLjGlMiBeC_xHqqkZx_
//	FDSECTIME	m_fdstSessionTime;		// _xZkqqHx_iDfKiDgCiDfGiDiHiDjDiOjOiKnEiBeC_xHqqkZx_
//----- 06.04.06 Fukushiro M. _xZkqqHx_iNoNiPjMiPeJ_xHqqkZx_ ()-----

// _xZkqqHx_iDeBiDgHiDiKiDhCiDiFiBfLiDgH_xHqqkZx_
public:

// _xZkqqHx_iDeJiDhJiDiMiBfLiDfGiDiHiDjD_xHqqkZx_
public:

// _xZkqqHx_iDeJiBfLiDgPiBfLiDiJiDeDiDgI_xHqqkZx_
	// ClassWizard _xZkqqHx_iCmNiJlMjBhKiKnGjAjEiCmMiDeJiBfLiDgPiBfLiDiJiDeDiDgIiCpAjAlGjAkMiClFiCnMiClHiBeC_xHqqkZx_
	//{{AFX_VIRTUAL(CFCHistViewFrame)
	//}}AFX_VIRTUAL

// _xZkqqHx_iDeDiDjDiDhGiDiKiDiBiDjDiDgFiBfLiDfGiDiHiDjD_xHqqkZx_
protected:
	virtual ~CFCHistViewFrame();

protected:  // _xZkqqHx_iDfCiDjDiDgHiDiNiBfLiDiL_xHqqkZx_ _xZkqqHx_iDgPiBfLjHhAiDiBiDjDiDgP_xHqqkZx_
	CFCTolBrTools		m_wndToolBoxBar;
	CFCTolBrSheet		m_tolBrSheet;		// _xZkqqHx_iDfGiBfLiDgHiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	CFCTolBrLayer		m_tolBrLayer;		// _xZkqqHx_iDiMiDeDiDiEiBfLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	CFCTolBrObjLabel	m_tolBrObjLabel;	// _xZkqqHx_iDiJiDhIiDiLiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_
	CFCTolBrBase		m_tolBrHtreeSearch;	// _xZkqqHx_jHjKjHpAiMjPiNpFiDgDiBfLiDiLiDgPiBfLiBeC_xHqqkZx_

	// _xZkqqHx_jAlGjAkMiClDiCoKiClNiDiBiDgCiDfKiBfLiDfH_xHqqkZx_ _xZkqqHx_iDhNiDgCiDhGiKnGjAjE_xHqqkZx_
	//{{AFX_MSG(CFCHistViewFrame)
	afx_msg void OnViewHtreeFindPanel();
	afx_msg void OnUpdateViewHtreeFindPanel(CCmdUI* pCmdUI);
	afx_msg void OnOptionEnv();
	afx_msg void OnUpdateOptionEnv(CCmdUI* pCmdUI);
	afx_msg void OnOptionHistoryMoveOpeList();
	afx_msg void OnUpdateOptionHistoryMoveOpeList(CCmdUI* pCmdUI);
	afx_msg void OnHtreeSelectMoveOperation();
	afx_msg void OnUpdateHtreeSelectMoveOperation(CCmdUI* pCmdUI);
	afx_msg void OnHtreeFindPanel();
	afx_msg void OnUpdateHtreeFindPanel(CCmdUI* pCmdUI);
	afx_msg void OnHtreeFindResults();
	afx_msg void OnUpdateHtreeFindResults(CCmdUI* pCmdUI);
	afx_msg void OnHtreeJumpNextFindResult();
	afx_msg void OnUpdateHtreeJumpNextFindResult(CCmdUI* pCmdUI);
	afx_msg void OnHtreeJumpPrevFindResult();
	afx_msg void OnUpdateHtreeJumpPrevFindResult(CCmdUI* pCmdUI);
	afx_msg void OnHtreeJumpCurrentFindResult();
	afx_msg void OnUpdateHtreeJumpCurrentFindResult(CCmdUI* pCmdUI);
	afx_msg void OnViewAppendDsm();
	afx_msg void OnUpdateViewAppendDsm(CCmdUI* pCmdUI);
	afx_msg void OnViewDsmPanel();
	afx_msg void OnUpdateViewDsmPanel(CCmdUI* pCmdUI);
	afx_msg void OnViewPrevDsm();
	afx_msg void OnUpdateViewPrevDsm(CCmdUI* pCmdUI);
	afx_msg void OnViewNextDsm();
	afx_msg void OnUpdateViewNextDsm(CCmdUI* pCmdUI);
	afx_msg void OnViewCurrentDsm();
	afx_msg void OnUpdateViewCurrentDsm(CCmdUI* pCmdUI);
	afx_msg void OnViewDeleteDsm();
	afx_msg void OnUpdateViewDeleteDsm(CCmdUI* pCmdUI);
	afx_msg void OnRbtnHtreeChangeBranchIntoTrunk();
	afx_msg void OnUpdateRbtnHtreeChangeBranchIntoTrunk(CCmdUI* pCmdUI);
	afx_msg void OnRbtnHtreeChangeTrunkIntoBranch();
	afx_msg void OnUpdateRbtnHtreeChangeTrunkIntoBranch(CCmdUI* pCmdUI);
	afx_msg void OnRbtnHtreeChangeBranchIntoTop();
	afx_msg void OnUpdateRbtnHtreeChangeBranchIntoTop(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg LRESULT OnUserSetHiMoveOperation(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserDsmUpdated(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

// 06.04.06 Fukushiro M. 1_xZkqqHx_iNhDiNoNiPjM_xHqqkZx_ ()
//	afx_msg LRESULT OnUserPursuerTextNeedInfo (WPARAM wParam, LPARAM lParam = 0);

}; // class CFCHistViewFrame.

// _xZkqqHx_jHjKjHpAiDhCiDiFiBfLiDeBiDhEiDiMiBfLiDiAiDeJiDhFiDfHiDeGiDeOiDgHiBeC_xHqqkZx_
inline CFCHistViewFrame* FFHistViewFrame ()
{
	if (FFGetMainWnd()->GetWnd()->IsKindOf(RUNTIME_CLASS(CFCHistViewFrame)))
		return (CFCHistViewFrame*)g_pFrame;
	else
		return NULL;
} // FFHistViewFrame.

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ _xZkqqHx_iCmNjBePiNhDiCmMjClMjBePiCmJjCmHiJmBiCmMjAoJiMlOiCpAjBhNjDpMiClFiCnMiClHiBeC_xHqqkZx_

#endif // !defined(AFX_HISTVIEWFRAME_H__47A52CC3_E202_11D2_ACBD_00C0F6B0E2D0__INCLUDED_)
